//////////////////////////////////////////////////////
//  Importer
//////////////////////////////////////////////////////

import java.net.*;
import java.applet.*;
import java.awt.*;
import java.awt.image.*;

//////////////////////////////////////////////////////
//  Klass Alpha
//////////////////////////////////////////////////////

/** Innehller funktioner fr textutmatning till skrmen. */
public class Alpha
{
    // Ordningen p tecknen
    private final String chars="0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ.'-: ";
    
    private Image[] b;             // Grafikversioner av bokstver, siffror m.fl. tecken
    private int NB=chars.length(); // Antalet tecken i teckensnittet.
    private int w, h;              // Tecknens bredd och hjd
    
    private Applet a;
    
    /** Skapar ett utskriftsobjekt. Konstruktorn laddar in bilderna */
    public Alpha(Applet applet)
    {
	a=applet;
	
	// Ladda bilder
	MediaTracker tracker=new MediaTracker(a);
	b=new Image[NB];
	for(int i=0;i<NB;i++)
	    {
		b[i]=a.getImage(a.getCodeBase(), "pix/"+getString(i)+".jpg");
		tracker.addImage(b[i], i);
	    }
	try{tracker.waitForAll();}
	catch(InterruptedException e){}
	w=b[0].getWidth(a);
	h=b[0].getHeight(a);
    }
    
    /** Skriver ut en strng till skrmen. */
    public void print(Graphics g, String s, int x, int y)
    {
	for(int i=0;i<s.length();i++,x++)
	    print(g, s.charAt(i), x, y);
    }
    
    /** Skriver ut ett tecken till skrmen. */
    public void print(Graphics g, char c, int x, int y)
    {
	printExact(g, c, x*w, y*h);
    }
    
    /** Skriver ut ett tecken till skrmen, med pixelnoggrannhet. */
    public void printExact(Graphics g, char c, int x, int y)
    {
	try{g.drawImage(bokstav(c), x, y, a);}
	catch(Exception e){}
    }
    
    /* Hmtar en bild som representerar en bokstav. */
    Image bokstav(char c) throws Exception
    {
	int i=chars.indexOf(c);
	if(i<0) throw(new Exception());
	return b[i];
    }
    
    /** Gr om en integer till en tvbokstavsstrng. */
    private String getString(int n)
    {
	String ret=""+((n/10)%10);
	ret+=n%10;
	return ret;
    }
    
    /** Returnerar teckenbredden. */
    public int getWidth()
    {
	return w;
    }
    
    /** Returnerar teckenhjden. */
    public int getHeight()
    {
	return h;
    }
}
