//////////////////////////////////////////////////////
//  Importer
//////////////////////////////////////////////////////

import java.applet.*;
import java.awt.*;
import java.awt.image.*;

//////////////////////////////////////////////////////
//  Klass Box
//////////////////////////////////////////////////////

/** Ldorna som kan ritas till skrmen.
    De kan ses som frglagda kvadrater. */
public class Box
{
    private Applet a;
    private Image pic[];
    private final int N=8;
    
    /** Skapar en ld-hanterare fr Tetris-grafiken. */
    public Box(Applet applet)
    {
	a=applet;
	
	// Ladda bilder
	MediaTracker tracker=new MediaTracker(a);
	pic=new Image[N];
	for(int i=0;i<N;i++)
	    {
		pic[i]=a.getImage(a.getCodeBase(), "pix/b"+i+".jpg");
		tracker.addImage(pic[i], i);
	    }
	try{tracker.waitForAll();}
	catch(InterruptedException e){}
    }
    
    /** Ritar ut hela spelfltet som grafik. */
    public void plot(Graphics g, Playfield f)
    {
	for(int j=0;j<f.getHeight();j++)
	    for(int i=0;i<f.getWidth();i++)
		if(f.get(i,j)>=0)
		    plot(g, f.get(i,j), i, j);
    }
    
    /** Ritar ut en ruta som grafik. */
    private void plot(Graphics g, int blk, int x, int y)
    {
	plotExact(g, blk, x*16, y*16);
    }
    
    /** Ritar ut en ruta med pixelnoggrannhet. */
    public void plotExact(Graphics g, int blk, int x, int y)
    {
	g.drawImage(pic[blk], x, y, a);
    }
}
