//////////////////////////////////////////////////////
//  Importer
//////////////////////////////////////////////////////

import java.lang.*;

//////////////////////////////////////////////////////
//  Klass ScoreAnimator
//////////////////////////////////////////////////////

/** Animerar pongen. */
public class ScoreAnimator
    implements Runnable
{
    private Thread animator;      // Fr att "rulla" pongen
    private ScoreReceiver sr;     // Uppdaterar pongen p skrmen
    private int delay;            // Delay
    private int screenScore;      // Pong som visas p skrmen
    private int score;            // Faktiskt pong
    private int step;             // S snabbt som pongen stegas upp
    
    /** Skapar ett pongobjekt, som rullar upp pongen fint p skrmen. */
    public ScoreAnimator(ScoreReceiver scoreReceiver, int delay, int step)
    {
	sr=scoreReceiver;
	this.delay=delay;
	this.step=step;
    }
    
    /** Startar animeringen av ponghllningen. */
    public void start()
    {
	animator=new Thread(this);
	animator.start();
    }
    
    /** Stoppar animeringen av ponghllningen. */
    public void stop()
    {
	animator=null;
    }
    
    /** Krvs av Runnable. */
    public void run()
    {
	while(animator!=null)
	    {
		if(score!=screenScore)
		    {
			if(score>screenScore)
			    screenScore+=step;
			if(score<screenScore)
			    screenScore=score;
			sr.printScore(screenScore);
		    }
		try{animator.sleep(delay);}
		catch(InterruptedException e){}
	    }
    }
    
    /** Stter pongen som ScoreAnimator ska "animera fram". */
    public void setScore(int score)
    {
	this.score=score;
    }
}
